@version 2.7
@warnings
@script generic

/*
00:"None",
01:"2D Arrow",			02:"2D Arrow(F)",
03:"2D Double Arrow",	04:"2D Double Arrow(F)",
05:"3D Arrow",			06:"3D Double Arrow",
07:"3D Pin",			08:"3D Pin(F)",
09:"2D Triangle",		10:"2D Triangle(F)",
11:"2D Double Triangle",12:"2D Double Triangle(F)",
13:"3D Tri Pyramid",	14:"3D Tri Pyramid(F)",
15:"3D Pyramid",		16:"3D Pyramid(F)",
17:"3D Box",			18:"3D Box(F)",
19:"3D Octahedron",		20:"3D Octahedron(F)",
21:"2D Circle",			22"2D Circle(F)",
23:"2D Dial",			24:"2D Dial(F)",
25:"3D Ball",
26:"3D LeftHand",		27:"3D RightHand",
28:"3D Foot"
29:"2D Cross Arrow"		30:"2D Cross Arrow(F)"
31:"3D Cross Arrow"

#pragma pack(1)
typedef struct st_comData {
	LWItemID item;		// Plugin Owner itemID
	int shape;			// 0-31
	int axis;			// 0-5(-X, +X, -Y, +Y, -Z, +Z)
	int twist;			// 0-3(0, 90, 180, 270)
	double scale[3];	// Scale %
	double shift[3];	// Position
	int isCross;		// 0-1(Draw Center Cross)
	int noPick;			// 0-1(No Pickup) v.210
	double cmntPos[3];	// comment Position
	int isCmnt;			// 0-1(Show Comment)
	int align;			// 0-2(left, center, right)
	char cmnt[32];		// comment string(max 30)
	int lineType;		// 0-3(Solid, Dot, Dash, LongDot) v.213
	int isColor;		// 0-1(UseCostomColor) v.213
	float rgba[4];		// RGBA v.213
} comData;
#pragma pack()
*/

@define CO_COMRING_EVENT_READ		(100)
@define CO_COMRING_EVENT_WRITE		(200)
@define CO_COMRING_TOPIC	"AS_CustomObj"

// struct(dataList)
COData = @"i", "i", "i", "i", "d#3", "d#3", "i", "i", "d#3", "i", "i", "s:32", "i", "i", "f#4"@;

generic{
//debug();
	var curItems = Scene().getSelect();
	if(!curItems) return;
	num = curItems.size();

// sample/initial value
	var item  = 0;
	var shape = 0;
	var axis  = 5;
	var twist = 0;
	var scl   = @0.25, 0.25, 0.25@;
	var sft   = @0.0, 0.0, 0.0@;
	var cross   = 0;
	var pick    = 0;
	var cmPos   = @0.0, 0.0, 0.0@;
	var isCmnt  = 0;
	var justify = 1;
	var cmnt    = "";
	var lineType= 0;
	var isColor = 0;
	var rgba    = @0.0, 0.0, 0.0, 1.0@;

	comringattach(CO_COMRING_TOPIC, "comringEvent");

for(i = 1; i <= num; ++i){ // sample Loop Start

// Plugin Owner ID
	item = curItems[i].id;

// read
//	datablob = comringencode(COData, 0, 0, 0, 0, @0,0,0@, @0,0,0@, 0, 0, @0,0,0@, 0, 0, "", 0, 0, @0.0, 0.0, 0.0, 1.0@);
	datablob = comringencode(COData, item, shape, axis, twist, scl, sft, cross, pick, cmPos, isCmnt, align, cmnt, lineType, isColor, rgba);
	comringmsg(CO_COMRING_TOPIC, CO_COMRING_EVENT_READ, datablob);

	// (,,,) = fn(); statement isn't suppurt arrayElement. (a[1],a[2],a[3],,,) == NG. (a,b,c,,,) == OK.
	(item, shape, axis, twist, sclX,sclY,sclZ, sftX,sftY,sftZ, cross, pick, cPX,cPY,cPZ, isCmnt, align, cmnt, lineType, isColor, cR,cG,cB,cA) = 
		comringdecode(COData, datablob);
	scl[1]=sclX; scl[2]=sclY; scl[3]=sclZ;
	sft[1]=sftX; sft[2]=sftY; sft[3]=sftZ;
	cmPos[1]=cPX; cmPos[2]=cPY; cmPos[3]=cPZ;
	rgba[1]=cR; rgba[2]=cG; rgba[3]=cB; rgba[4]=cA;

// change Param
	shape = 1;

// write
	datablob = comringencode(COData, item, shape, axis, twist, scl, sft, cross, pick, cmPos, isCmnt, align, cmnt, lineType, isColor, rgba);
	comringmsg(CO_COMRING_TOPIC, CO_COMRING_EVENT_WRITE, datablob);

} // sample Loop End

	comringdetach(CO_COMRING_TOPIC);
}

comringEvent: code, data
{
}
